<script setup lang="ts">
import { useAttendanceStore } from '@/stores/attendance'
import { useAuthStore } from '@/stores/auth'
import { onMounted, ref } from 'vue'

const attendanceStore = useAttendanceStore()
const authStore = useAuthStore()

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'EmployeeId',
    key: 'employeeId',
    value: 'employeeId'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Date',
    key: 'date',
    value: 'date'
  },
  {
    title: 'Clock In',
    key: 'clockIn',
    value: 'clockIn'
  },
  {
    title: 'Clock Out',
    key: 'clockOut',
    value: 'clockOut'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  {
    title: 'Working Hours',
    key: 'workedTime',
    value: 'workedTime'
  }
]

const search = ref('')

onMounted(() => {
  const currentUser = authStore.getCurrentUser()
  if (currentUser?.employee?.id) {
    attendanceStore.getAllAttendanceByEmployeeId(currentUser?.employee?.id)
  } else {
    console.error('Current user is undefined or does not have an ID')
  }
})
</script>
<template>
  <v-toolbar flat style="background-color: rgb(247, 156, 82)">
    <v-toolbar-title style="color: white">History</v-toolbar-title>
    <v-spacer></v-spacer>
  </v-toolbar>
  <div>
    <v-data-table
      :headers="headers"
      :items="attendanceStore.attendances"
      :search="search"
      class="custom-datatable"
    >
      <template v-slot:header="{ headers }">
        <v-text-field
          rounded
          v-model="search"
          label="Search"
          prepend-inner-icon="mdi-magnify"
          variant="solo"
          hide-details
          single-line
        ></v-text-field>
        <tr>
          <th v-for="(item, index) in headers" :key="index">{{ item.title }}</th>
        </tr>
      </template>
      <template v-slot:items="{ items }">
        <tr v-for="(item, index) in items" :key="index">
          <td>{{ item.employee.id }}</td>
          <td>{{ item.name }}</td>
          <td>{{ item.clockIn }}</td>
          <td>{{ item.clockOut }}</td>
          <td>{{ item.status }}</td>
          <td>{{ item.workedTime }}</td>
        </tr>
      </template>
    </v-data-table>
  </div>
</template>
